"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.injectPartnerInfoToReq = exports.GKCache_remove = exports.GKCache_remember = exports.getCacheManage = exports.crashAfterMe = exports.ipwhitelist = exports.clearCache = exports.cacheAble = exports.modelSetting = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _redisClient = require("./redisClient");

var _util = require("./util");

var _isomorphicFetch = _interopRequireDefault(require("isomorphic-fetch"));

var _templateObject, _templateObject2;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _objectSpread2(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var _getCookieDomain2 = function _getCookieDomain2(reqOrHostName) {
  var hostname = '';

  if ((typeof window === "undefined" ? "undefined" : _typeof(window)) === "object") {
    hostname = window.location.hostname;
  } else {
    if (!reqOrHostName) {
      throw new Error('_getCookieDomain函数在服务器端运行时，需传入req或hostname值的参数');
    }

    hostname = _typeof(reqOrHostName) === "object" ? reqOrHostName.headers["host"] : reqOrHostName;
  }

  var _hostname$split$0$spl = hostname.split(":")[0].split(".").reverse(),
      _hostname$split$0$spl2 = _slicedToArray(_hostname$split$0$spl, 2),
      domainType = _hostname$split$0$spl2[0],
      _hostname$split$0$spl3 = _hostname$split$0$spl2[1],
      domain = _hostname$split$0$spl3 === void 0 ? '' : _hostname$split$0$spl3;

  return "".concat(domain, ".").concat(domainType);
};

var config = (0, _redisClient.getting_redisConfig)();
var _config$cache_prefx = config.cache_prefx,
    redis_cache_key_prefx = _config$cache_prefx === void 0 ? "redis_cache_key_prefx_" : _config$cache_prefx,
    _config$defaultExpire = config.defaultExpireSecond,
    defaultExpireSecond = _config$defaultExpire === void 0 ? 10 * 60 : _config$defaultExpire;

var modelSetting = function modelSetting(SettingOptions) {
  Object.keys(SettingOptions).map(function (key, value) {
    if (key.indexOf("__") !== 0) {
      throw new Error('动态添加的静态属性名不符合约定格式（__****）');
    }
  });

  var _props = _objectSpread2({}, SettingOptions);

  return function decorator(target) {
    target.__modelSetting = function () {
      return _props;
    };
  };
};

exports.modelSetting = modelSetting;
var ____cache = {
  get: function () {
    var _get = _asyncToGenerator(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee(akey) {
      var avalue;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              akey = redis_cache_key_prefx + akey;
              _context.next = 3;
              return (0, _redisClient.getRedisClient)().getAsync(akey);

            case 3:
              avalue = _context.sent;

              if (!avalue) {
                _context.next = 15;
                break;
              }

              _context.prev = 5;
              return _context.abrupt("return", JSON.parse(avalue));

            case 9:
              _context.prev = 9;
              _context.t0 = _context["catch"](5);
              console.log("redis\u7F13\u5B58[".concat(akey, "]\u5220\u9664\u5931\u8D25\uFF1A").concat(_context.t0)); //解析错误，则删除key

              _context.next = 14;
              return (0, _redisClient.getRedisClient)().delAsync(akey);

            case 14:
              return _context.abrupt("return", null);

            case 15:
              return _context.abrupt("return", avalue);

            case 16:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[5, 9]]);
    }));

    function get(_x) {
      return _get.apply(this, arguments);
    }

    return get;
  }(),
  set: function () {
    var _set = _asyncToGenerator(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee3(akey, avalue, expireTimeSeconds) {
      return _regenerator["default"].wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              PrintCacheLog("set cachekey .......".concat(akey, "..."));
              akey = redis_cache_key_prefx + akey;
              (0, _util.delayRun)(
              /*#__PURE__*/
              _asyncToGenerator(
              /*#__PURE__*/
              _regenerator["default"].mark(function _callee2() {
                return _regenerator["default"].wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        _context2.next = 2;
                        return (0, _redisClient.getRedisClient)().setAsync(akey, JSON.stringify(avalue), 'EX', expireTimeSeconds || defaultExpireSecond);

                      case 2:
                      case "end":
                        return _context2.stop();
                    }
                  }
                }, _callee2);
              })), 0, function (err) {
                PrintCacheLog("redis\u7F13\u5B58[".concat(akey, "]\u5EFA\u7ACB\u5931\u8D25\uFF1A").concat(err));
              });

            case 3:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));

    function set(_x2, _x3, _x4) {
      return _set.apply(this, arguments);
    }

    return set;
  }(),
  "delete": function () {
    var _delete2 = _asyncToGenerator(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee5(akey) {
      return _regenerator["default"].wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              akey = redis_cache_key_prefx + akey;
              (0, _util.delayRun)(
              /*#__PURE__*/
              _asyncToGenerator(
              /*#__PURE__*/
              _regenerator["default"].mark(function _callee4() {
                return _regenerator["default"].wrap(function _callee4$(_context4) {
                  while (1) {
                    switch (_context4.prev = _context4.next) {
                      case 0:
                        _context4.next = 2;
                        return (0, _redisClient.getRedisClient)().delAsync(akey);

                      case 2:
                        PrintCacheLog("delete cachekey .......".concat(akey, "..."));

                      case 3:
                      case "end":
                        return _context4.stop();
                    }
                  }
                }, _callee4);
              })), 0, function (err) {
                PrintCacheLog("redis\u7F13\u5B58[".concat(akey, "]\u5220\u9664\u5931\u8D25\uFF1A").concat(err));
              });

            case 2:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5);
    }));

    function _delete(_x5) {
      return _delete2.apply(this, arguments);
    }

    return _delete;
  }()
};

var PrintCacheLog = function PrintCacheLog(msg) {
  if (process.env.PRINT_API_CACHE === '1') {
    console.log(msg);
  }
};
/**
 * 在被修饰的方法运行前后执行，首先判断是否存在相同入参的调用缓存，如果没有则在运行结束后，将要运行结果缓存。缓存的key由默认参数属性cacheKeyGene的返回值决定。
 * 默认缓存时间60秒
 * @param isGraphQL
 * @param cacheKeyGene
 * @param getExpireTimeSeconds
 * @returns {Function}
 */


var cacheAble = function cacheAble(_ref3) {
  var _ref3$isGraphQL = _ref3.isGraphQL,
      isGraphQL = _ref3$isGraphQL === void 0 ? false : _ref3$isGraphQL,
      cacheKeyGene = _ref3.cacheKeyGene,
      getExpireTimeSeconds = _ref3.getExpireTimeSeconds;
  var _cacheKeyGene = cacheKeyGene;
  return function (target, name, descriptor) {
    //兼容babel 7的变化
    name = name || target.key;
    descriptor = descriptor || target.descriptor; //修饰器的报错，级别更高，直接抛出终止程序

    if (!_cacheKeyGene) {
      setTimeout(function () {
        throw new Error("\u5728\u7C7B\u9759\u6001\u65B9\u6CD5 ".concat(target.name, ".").concat(name, " \u4E0A\u8C03\u7528cacheAble\u4FEE\u9970\u5668\u65F6\u672A\u6307\u5B9A\u6709\u6548\u7684cacheKeyGene\u53C2\u6570"));
      });
    }

    var oldValue = descriptor.value;
    descriptor.value =
    /*#__PURE__*/
    _asyncToGenerator(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee6() {
      var _ref5,
          __nocache,
          key,
          _result,
          aSkip,
          result,
          expireTimeSeconds,
          _args6 = arguments;

      return _regenerator["default"].wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              if (!(process.env.NO_API_CACHE === '1')) {
                _context6.next = 5;
                break;
              }

              PrintCacheLog("[".concat(target.name, ".").concat(name, "] force skip cache by process.env.NO_API_CACHE ..."));
              _context6.next = 4;
              return oldValue.apply(void 0, _args6);

            case 4:
              return _context6.abrupt("return", _context6.sent);

            case 5:
              if (!(isGraphQL && _args6.length < 3)) {
                _context6.next = 10;
                break;
              }

              console.error("\u5728\u7C7B\u9759\u6001\u65B9\u6CD5 ".concat(target.name, ".").concat(name, " \u4E0A\u8C03\u7528cacheAble\u4FEE\u9970\u65F6\u6307\u5B9A\u4E86isGraphQL=true,\u4F46\u88AB\u4FEE\u9970\u7684\u65B9\u6CD5\u770B\u8D77\u6765\u7B7E\u540D\u4E0D\u50CF\u6807\u51C6\u7684prisma\u89C4\u8303\uFF1A\uFF08parent, params, ctx, info\uFF09,\u6682\u65F6\u8DF3\u8FC7\u7F13\u5B58\uFF0C\u7EE7\u7EED\u6267\u884C...."));
              _context6.next = 9;
              return oldValue.apply(void 0, _args6);

            case 9:
              return _context6.abrupt("return", _context6.sent);

            case 10:
              if (!(!isGraphQL && _args6.length > 2)) {
                _context6.next = 15;
                break;
              }

              console.error("\u5728\u7C7B\u9759\u6001\u65B9\u6CD5 ".concat(target.name, ".").concat(name, " \u4E0A\u8C03\u7528cacheAble\u4FEE\u9970\u65F6\u6307\u5B9A\u4E86isGraphQL=false,\u4F46\u88AB\u4FEE\u9970\u7684\u65B9\u6CD5\u770B\u8D77\u6765\u7B7E\u540D\u5374\u50CF\u6807\u51C6\u7684prisma\u89C4\u8303\uFF08parent, params, ctx, info\uFF09\uFF0C\u8BF7\u786E\u8BA4\u662F\u5426\u4E3AgraphQL/prisma\u7684API\u65B9\u6CD5,\u6682\u65F6\u8DF3\u8FC7\u7F13\u5B58\uFF0C\u7EE7\u7EED\u6267\u884C...."));
              _context6.next = 14;
              return oldValue.apply(void 0, _args6);

            case 14:
              return _context6.abrupt("return", _context6.sent);

            case 15:
              //注意，如果是graphQLServer，根据入参签名需取第三个参数：（parent, params, ctx, info）
              _ref5 = (isGraphQL ? _args6[2] : _args6[0]) || {}, __nocache = _ref5.__nocache;

              if (!__nocache) {
                _context6.next = 21;
                break;
              }

              PrintCacheLog("[".concat(target.name, ".").concat(name, "] force skip cache ........ ").concat(target.name, ".").concat(name));
              _context6.next = 20;
              return oldValue.apply(void 0, _args6);

            case 20:
              return _context6.abrupt("return", _context6.sent);

            case 21:
              if (____cache) {
                _context6.next = 26;
                break;
              }

              console.error("\u5185\u7F6Eredis\u5BF9\u8C61\u5C1A\u672A\u521D\u59CB\u5316\uFF0C\u8BF7\u5148\u8C03\u7528setting_redisConfig(redis)\u3001getRedisClient()\uFF01\u6682\u65F6\u8DF3\u8FC7\u7F13\u5B58\uFF0C\u7EE7\u7EED\u6267\u884C....");
              _context6.next = 25;
              return oldValue.apply(void 0, _args6);

            case 25:
              return _context6.abrupt("return", _context6.sent);

            case 26:
              key = '';

              if (!_cacheKeyGene) {
                _context6.next = 44;
                break;
              }

              _context6.next = 30;
              return _cacheKeyGene.apply(this, _args6);

            case 30:
              key = _context6.sent;

              if (typeof key !== "string") {
                //if (process.env.NODE_ENV !== 'production') {
                setTimeout(function () {
                  throw new Error("[".concat(target.name, ".").concat(name, "] \u7F13\u5B58\u4FEE\u9970\u5668\u7684cacheKeyGene\u51FD\u6570\u5FC5\u9700\u8FD4\u56DE\u5B57\u7B26\u4E32\u7ED3\u679C\uFF0C\u76EE\u524D\u662F ").concat(key, "..."));
                }); //}
              } //返回空字符串时，忽略


              if (!key) {
                _context6.next = 44;
                break;
              }

              _context6.next = 35;
              return ____cache.get(key);

            case 35:
              _result = _context6.sent;

              if (process.env.NODE_ENV !== 'production') {
                PrintCacheLog("query cachekey [".concat(key, "]:").concat(_result, "..."));
              }

              if (!_result) {
                _context6.next = 44;
                break;
              }

              aSkip = false;

              if (typeof _result === "string") {
                try {
                  _result = JSON.parse(_result);
                } catch (e) {
                  if (process.env.NODE_ENV !== 'production') {
                    console.error("parse error the data from redis: ".concat(_result));
                  }

                  aSkip = true;
                }
              }

              if (aSkip) {
                _context6.next = 44;
                break;
              }

              if (process.env.NODE_ENV !== 'production') {
                PrintCacheLog("[".concat(target.name, ".").concat(name, "] hit cachekey .......").concat(key, "..."));
              }

              if (_typeof(_result) === "object") {
                if (isGraphQL && _args6[2]) {
                  if (!_args6[2]._hitCaches) _args6[2]._hitCaches = {};
                  _args6[2]._hitCaches[name] = true;
                } else {
                  _result.__fromCache = true;
                }
              }

              return _context6.abrupt("return", _result);

            case 44:
              //if(process.env.NODE_ENV !=='production') {
              PrintCacheLog("[".concat(target.name, ".").concat(name, "] miss cachekey .......").concat(key, "...")); //}

              _context6.next = 47;
              return oldValue.apply(void 0, _args6);

            case 47:
              result = _context6.sent;

              if (!(_cacheKeyGene && key)) {
                _context6.next = 54;
                break;
              }

              expireTimeSeconds = null;
              if (getExpireTimeSeconds && typeof getExpireTimeSeconds === "function") expireTimeSeconds = getExpireTimeSeconds();

              if (!(result !== null)) {
                _context6.next = 54;
                break;
              }

              _context6.next = 54;
              return ____cache.set(key, JSON.stringify(result), expireTimeSeconds);

            case 54:
              return _context6.abrupt("return", result);

            case 55:
            case "end":
              return _context6.stop();
          }
        }
      }, _callee6, this);
    }));
    return descriptor;
  };
};
/**
 * 在被修饰方法运行完毕后执行，用来清除一些相关的缓存
 *
 * @param cacheKeyGene
 * @returns {Function}
 */


exports.cacheAble = cacheAble;

var clearCache = function clearCache(_ref6) {
  var cacheKeyGene = _ref6.cacheKeyGene;
  // console.log( `clearCache:`   )
  // console.log( `cacheKeyGene:`+ cacheKeyGene   )
  return function (target, name, descriptor) {
    // console.log( `clearCache function:`+ target   )
    //兼容babel 7的变化
    name = name || target.key;
    descriptor = descriptor || target.descriptor;
    var oldValue = descriptor.value;
    descriptor.value =
    /*#__PURE__*/
    _asyncToGenerator(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee7() {
      var key,
          _args7 = arguments;
      return _regenerator["default"].wrap(function _callee7$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              if (!(process.env.NO_API_CACHE === '1')) {
                _context7.next = 5;
                break;
              }

              PrintCacheLog("force skip cache by process.env.NO_API_CACHE ...");
              _context7.next = 4;
              return oldValue.apply(void 0, _args7);

            case 4:
              return _context7.abrupt("return", _context7.sent);

            case 5:
              key = '';

              if (!(typeof cacheKeyGene === "function")) {
                _context7.next = 20;
                break;
              }

              key = cacheKeyGene.apply(void 0, _args7);

              if (!(typeof key !== "string")) {
                _context7.next = 12;
                break;
              }

              //if (process.env.NODE_ENV !== 'production') {
              PrintCacheLog("[".concat(target.name, ".").concat(name, "] \u7F13\u5B58\u4FEE\u9970\u5668\u7684cacheKeyGene\u51FD\u6570\u5FC5\u9700\u8FD4\u56DE\u5B57\u7B26\u4E32\u7ED3\u679C\uFF0C\u76EE\u524D\u662F ").concat(key, "...")); //}

              _context7.next = 18;
              break;

            case 12:
              if (!(key === "")) {
                _context7.next = 16;
                break;
              }

              //返回的key为空字符串，说明key无法提前确定，需要交给方法内部来调用清空
              _args7[0].__cacheManage = function () {
                return ____cache;
              };

              _context7.next = 18;
              break;

            case 16:
              _context7.next = 18;
              return ____cache["delete"](key);

            case 18:
              _context7.next = 21;
              break;

            case 20:
              //修饰器的报错，级别更高，直接抛出终止程序
              setTimeout(function () {
                throw new Error("\u5728\u7C7B\u9759\u6001\u65B9\u6CD5 ".concat(target.name, ".").concat(name, " \u4E0A\u8C03\u7528cacheAble\u4FEE\u9970\u5668\u65F6\u672A\u6307\u5B9A\u6709\u6548\u7684cacheKeyGene\u53C2\u6570"));
              });

            case 21:
              _context7.next = 23;
              return oldValue.apply(void 0, _args7);

            case 23:
              return _context7.abrupt("return", _context7.sent);

            case 24:
            case "end":
              return _context7.stop();
          }
        }
      }, _callee7);
    }));
    return descriptor;
  };
};
/**
 * 实际用在API入口处判断，很少用在类的方法级别
 *
 * @returns {Function}
 */


exports.clearCache = clearCache;

var ipwhitelist = function ipwhitelist() {
  return function (target, name, descriptor) {
    // console.log( `cacheAble:`+ target   )
    if (!descriptor) {
      throw new Error('ipwhitelist不支持修饰类');
    } //兼容babel 7的变化


    name = name || target.key;
    descriptor = descriptor || target.descriptor;
    var oldValue = descriptor.value;
    descriptor.value =
    /*#__PURE__*/
    _asyncToGenerator(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee8() {
      var _ref9,
          req,
          _args8 = arguments;

      return _regenerator["default"].wrap(function _callee8$(_context8) {
        while (1) {
          switch (_context8.prev = _context8.next) {
            case 0:
              _ref9 = _args8.length > 0 ? _typeof(_args8[0]) === "object" ? _args8[0] : {} : {}, req = _ref9.req;

              if (!req) {
                //修饰器的报错，级别更高，直接抛出终止程序
                setTimeout(function () {
                  throw new Error("\u9759\u6001\u7C7B\u65B9\u6CD5 ".concat(target.name, ".").concat(name, " \u4E2D\u8981\u6C42\u9650\u5B9AIP\u767D\u540D\u5355\uFF0C\u4F46\u662F\u6CA1\u6709req\u8BF7\u6C42\u53C2\u6570\u4F20\u5165\uFF0C\u65E0\u6CD5\u5B9E\u65BDIP\u9650\u5236"));
                });
              }

              if (whiteIPs.indexOf((0, _util.getClientIp)(req)) === -1) {
                //修饰器的报错，级别更高，直接抛出终止程序
                setTimeout(function () {
                  throw new Error("IP\u6CA1\u6709\u8BBF\u95EE\u6743\u9650");
                });
              }

              _context8.next = 5;
              return oldValue.apply(void 0, _args8);

            case 5:
              return _context8.abrupt("return", _context8.sent);

            case 6:
            case "end":
              return _context8.stop();
          }
        }
      }, _callee8);
    }));
    return descriptor;
  };
};
/**
 * 修饰器,运行完类方法就认为跑出异常中断程序，调试用，生产环境下自动失效
 *
 * @param hintMsg
 * @returns {Function}
 */


exports.ipwhitelist = ipwhitelist;

var crashAfterMe = function crashAfterMe(hintMsg) {
  return function (target, name, descriptor) {
    // console.log(`crashAfterMe:` + target)
    if (!descriptor) {
      throw new Error('crashAfterMe只支持修饰类方法本身，不支持修饰类');
    } //兼容babel 7的变化


    name = name || target.key;
    descriptor = descriptor || target.descriptor;

    if (process.env.NODE_ENV !== 'production') {
      var oldValue = descriptor.value;
      descriptor.value =
      /*#__PURE__*/
      _asyncToGenerator(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee9() {
        var ret,
            _args9 = arguments;
        return _regenerator["default"].wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                _context9.next = 2;
                return oldValue.apply(void 0, _args9);

              case 2:
                ret = _context9.sent;
                setTimeout(function () {
                  throw new Error("".concat(hintMsg || '调试用的中断', " by  crashAfterMe decorator\uFF01 \u975Eproduction\u73AF\u5883\uFF08").concat(process.env.NODE_ENV, "\uFF09"));
                }, 5);
                return _context9.abrupt("return", ret);

              case 5:
              case "end":
                return _context9.stop();
            }
          }
        }, _callee9);
      }));
    }

    return descriptor;
  };
};

exports.crashAfterMe = crashAfterMe;

var getCacheManage = function getCacheManage() {
  return ____cache;
};
/**
 * 缓存包装函数
 * @param cacheKey
 * @param cacheDurationSecond
 * @param callback
 * @param _cachemanage
 * @returns
 * @constructor
 */


exports.getCacheManage = getCacheManage;

var GKCache_remember =
/*#__PURE__*/
function () {
  var _ref11 = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee11(cacheKey, cacheDurationSecond, callback, _cachemanage) {
    var result, newResult;
    return _regenerator["default"].wrap(function _callee11$(_context11) {
      while (1) {
        switch (_context11.prev = _context11.next) {
          case 0:
            if (!((typeof window === "undefined" ? "undefined" : _typeof(window)) === "object")) {
              _context11.next = 2;
              break;
            }

            throw new Error('rememberCache函数仅限于Server端运行！无法在浏览器端中');

          case 2:
            if (!(typeof callback !== "function")) {
              _context11.next = 5;
              break;
            }

            console.error('typeof callback:', _typeof(callback));
            throw new Error('callback参数必须为function');

          case 5:
            if (!_cachemanage) {
              _context11.next = 8;
              break;
            }

            if (_cachemanage.put) {
              _context11.next = 8;
              break;
            }

            throw new Error('提供给GKCache_remember的_cachemanage参数必须实现.put()方法');

          case 8:
            if (!_cachemanage) {
              _context11.next = 12;
              break;
            }

            _context11.t0 = _cachemanage.get(cacheKey);
            _context11.next = 15;
            break;

          case 12:
            _context11.next = 14;
            return ____cache.get(cacheKey);

          case 14:
            _context11.t0 = _context11.sent;

          case 15:
            result = _context11.t0;

            if (!result) {
              _context11.next = 18;
              break;
            }

            return _context11.abrupt("return", result);

          case 18:
            _context11.next = 20;
            return callback();

          case 20:
            newResult = _context11.sent;

            if (!(newResult == null)) {
              _context11.next = 23;
              break;
            }

            return _context11.abrupt("return", newResult);

          case 23:
            if (~~cacheDurationSecond < 5) console.warn("GKCache_remember \u7684 cacheDurationSecond \u53C2\u6570\u7F13\u5B58\u65F6\u957F\u9700\u5927\u4E8E5\u79D2");
            setTimeout(
            /*#__PURE__*/
            _asyncToGenerator(
            /*#__PURE__*/
            _regenerator["default"].mark(function _callee10() {
              return _regenerator["default"].wrap(function _callee10$(_context10) {
                while (1) {
                  switch (_context10.prev = _context10.next) {
                    case 0:
                      if (!_cachemanage) {
                        _context10.next = 4;
                        break;
                      }

                      // Time in ms
                      _cachemanage.put(cacheKey, newResult, cacheDurationSecond * 1000, function (key, value) {//on set success ...
                      });

                      _context10.next = 7;
                      break;

                    case 4:
                      if (_typeof(newResult) == "object") {
                        newResult = JSON.stringify(newResult);
                      }

                      _context10.next = 7;
                      return ____cache.set(cacheKey, newResult, Math.max(5, ~~cacheDurationSecond));

                    case 7:
                    case "end":
                      return _context10.stop();
                  }
                }
              }, _callee10);
            })));
            return _context11.abrupt("return", newResult);

          case 26:
          case "end":
            return _context11.stop();
        }
      }
    }, _callee11);
  }));

  return function GKCache_remember(_x6, _x7, _x8, _x9) {
    return _ref11.apply(this, arguments);
  };
}();

exports.GKCache_remember = GKCache_remember;

var GKCache_remove =
/*#__PURE__*/
function () {
  var _ref13 = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee12(cacheKey) {
    return _regenerator["default"].wrap(function _callee12$(_context12) {
      while (1) {
        switch (_context12.prev = _context12.next) {
          case 0:
            _context12.next = 2;
            return ____cache["delete"](cacheKey);

          case 2:
          case "end":
            return _context12.stop();
        }
      }
    }, _callee12);
  }));

  return function GKCache_remove(_x10) {
    return _ref13.apply(this, arguments);
  };
}();
/**
 * 渠道识别中间件，在express的req对象上注入__partner(如发生异常则会留下__partner_error)。
 * @param expressObj
 * @param GKP
 */


exports.GKCache_remove = GKCache_remove;

var injectPartnerInfoToReq = function injectPartnerInfoToReq(expressObj, GKP, yunyingApiHost) {
  if (!expressObj.injected) {
    console.log("expressObj.injected:", expressObj.injected);
    expressObj.injected = true;
    expressObj.use(
    /*#__PURE__*/
    function () {
      var _ref14 = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee14(req, res, next) {
        var hostname, _ref15, __partner, __partner_error;

        return _regenerator["default"].wrap(function _callee14$(_context14) {
          while (1) {
            switch (_context14.prev = _context14.next) {
              case 0:
                if (!((req.path || "").indexOf("/_next/") > -1)) {
                  _context14.next = 2;
                  break;
                }

                return _context14.abrupt("return", next());

              case 2:
                hostname = req.headers["host"];
                _context14.next = 5;
                return GKCache_remember(hostname, 60,
                /*#__PURE__*/
                _asyncToGenerator(
                /*#__PURE__*/
                _regenerator["default"].mark(function _callee13() {
                  var env_name, apiUrl, query, res2, jsonResult, err, result, _ref17, partner;

                  return _regenerator["default"].wrap(function _callee13$(_context13) {
                    while (1) {
                      switch (_context13.prev = _context13.next) {
                        case 0:
                          //loadPartnerInfo TODo
                          //这里的process.env.PRODUCTION_TYPE会在babel编译期被替换为实际值
                          env_name = process.env.PRODUCTION_TYPE || 'development'; //TODO：注意，这个api接口，最后也需要切换

                          yunyingApiHost = yunyingApiHost || "https://api.".concat(env_name === "production" ? "gankao.com" : "gankaotest2.com", "/api-yunying");
                          apiUrl = yunyingApiHost + "/gkpartner/getPartnerInfoFromSomeString?partnerIdOrEnameOrHostName=".concat(hostname);
                          query = {
                            method: 'GET',
                            rejectUnauthorized: false,
                            headers: {
                              'Accept': 'application/json, text/plain, */*',
                              'Content-Type': 'application/json'
                            },
                            json: true
                          };

                          if (process.env.DEBUG == 1) {
                            console.log("apiUrl:", apiUrl);
                            console.log("query:", query);
                          }

                          _context13.next = 7;
                          return (0, _isomorphicFetch["default"])(apiUrl, query);

                        case 7:
                          res2 = _context13.sent;
                          _context13.next = 10;
                          return res2.json();

                        case 10:
                          jsonResult = _context13.sent;

                          if (process.env.DEBUG == 1) {
                            console.log(jsonResult);
                          }

                          err = jsonResult.err, result = jsonResult.result;

                          if (!err) {
                            _context13.next = 17;
                            break;
                          }

                          return _context13.abrupt("return", {
                            __partner: null,
                            __partner_error: err
                          });

                        case 17:
                          _ref17 = result || {}, partner = _ref17.partner;

                          if (partner) {
                            delete partner.encrypt;

                            try {
                              partner.settings = JSON.parse(partner.settings);
                            } catch (e) {
                              partner.settings = {
                                __message: 'parse error in api'
                              };
                            }

                            partner.aimodel = ~~partner.orgType === 2 ? 2 : partner.aimodel; //

                            try {
                              //渠道存在，则补一个cookie
                              if (!res.cookie.PARTNER_ID || res.cookie.PARTNER_ID !== partner.ename) {
                                res.cookie("PARTNER_ID", partner.ename, {
                                  domain: _getCookieDomain2(req),
                                  httpOnly: true,
                                  path: '/'
                                });
                              }

                              if (!res.cookie.channel_id || res.cookie.channel_id !== partner.ename) {
                                res.cookie("channel_id", partner.ename, {
                                  domain: _getCookieDomain2(req),
                                  httpOnly: true,
                                  path: '/'
                                });
                              }
                            } catch (e) {
                              console.error(e.message);
                            }
                          }

                          return _context13.abrupt("return", {
                            __partner: partner,
                            __partner_error: null
                          });

                        case 20:
                        case "end":
                          return _context13.stop();
                      }
                    }
                  }, _callee13);
                })));

              case 5:
                _ref15 = _context14.sent;
                __partner = _ref15.__partner;
                __partner_error = _ref15.__partner_error;
                req.__partner = __partner;
                req.__partner_error = __partner_error;
                next();

              case 11:
              case "end":
                return _context14.stop();
            }
          }
        }, _callee14);
      }));

      return function (_x11, _x12, _x13) {
        return _ref14.apply(this, arguments);
      };
    }());
    /**
     * 测试打印当前域名的机构渠道信息
     */

    expressObj.use(GKP(_templateObject || (_templateObject = _taggedTemplateLiteral(["/_printPartner"]))),
    /*#__PURE__*/
    function () {
      var _ref18 = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee15(req, res, next) {
        return _regenerator["default"].wrap(function _callee15$(_context15) {
          while (1) {
            switch (_context15.prev = _context15.next) {
              case 0:
                res.json(req.__partner || {});

              case 1:
              case "end":
                return _context15.stop();
            }
          }
        }, _callee15);
      }));

      return function (_x14, _x15, _x16) {
        return _ref18.apply(this, arguments);
      };
    }());
    /**
     * 存活行探针，内有300毫秒的等待，配合压力测试
     */

    expressObj.use(GKP(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["/_hello"]))),
    /*#__PURE__*/
    function () {
      var _ref19 = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee16(req, res, next) {
        var _req$query$test, test;

        return _regenerator["default"].wrap(function _callee16$(_context16) {
          while (1) {
            switch (_context16.prev = _context16.next) {
              case 0:
                _req$query$test = req.query.test, test = _req$query$test === void 0 ? 0 : _req$query$test;

                if (!(~~test === 1)) {
                  _context16.next = 4;
                  break;
                }

                _context16.next = 4;
                return (0, _util.sleep)(300);

              case 4:
                res.json({
                  ok: "hello! try to pass ?test=1 "
                });

              case 5:
              case "end":
                return _context16.stop();
            }
          }
        }, _callee16);
      }));

      return function (_x17, _x18, _x19) {
        return _ref19.apply(this, arguments);
      };
    }());
  }
};

exports.injectPartnerInfoToReq = injectPartnerInfoToReq;