"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = _default;

var _log4js = _interopRequireDefault(require("log4js"));

var _cluster = _interopRequireDefault(require("cluster"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/**
 * 多进程的日志配置
 */
function _default() {
  if (_cluster["default"].isMaster) {
    // Init master logger
    _log4js["default"].configure({
      appenders: [{
        // Adding only one, "clustered" appender.
        type: "clustered",
        // Add as many "normal" appenders as you like.
        // They will all be used once the "clustered" master appender receives a loggingEvent
        appenders: [{
          type: 'console'
        }]
      }],
      replaceConsole: false
    }); // Init logger like you used to


    return _log4js["default"].getLogger("master");
  } else {
    // Init worker loggers, adding only the clustered appender here.
    _log4js["default"].configure({
      appenders: [{
        type: "clustered"
      }],
      replaceConsole: false
    }); // Init logger like you used to


    return _log4js["default"].getLogger("worker_" + _cluster["default"].worker.id);
  }
}

;