"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.parallelInvokeWithPromise = exports.load_package_name = exports.hashcode = exports.delayRun = exports.crash = exports.sleep = exports.getClientIp = exports.varifyParamsWithMD5 = exports.signParamsWithMD5 = exports.getSignParamsInMD5 = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _md = _interopRequireDefault(require("md5"));

var _bluebird = _interopRequireDefault(require("bluebird"));

var _nodeFetch = _interopRequireDefault(require("node-fetch"));

var _path = _interopRequireDefault(require("path"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _objectSpread2(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

/**
 * 获得对象的MD5签名，按排序的key-value拼接字符串计算，value中的对象做JSON.stringify处理
 * @param param
 * @param secret
 * @param whiteProps
 * @param onlyAppendKeyValue
 * @returns {string}
 */
var getSignParamsInMD5 = function getSignParamsInMD5(_ref) {
  var _ref$param = _ref.param,
      param = _ref$param === void 0 ? {} : _ref$param,
      _ref$secret = _ref.secret,
      secret = _ref$secret === void 0 ? '' : _ref$secret,
      _ref$whiteProps = _ref.whiteProps,
      whiteProps = _ref$whiteProps === void 0 ? [] : _ref$whiteProps,
      _ref$onlyAppendKeyVal = _ref.onlyAppendKeyValue,
      onlyAppendKeyValue = _ref$onlyAppendKeyVal === void 0 ? false : _ref$onlyAppendKeyVal;
  var whiteList = ['pfx', 'partner_key', '_sign', 'sign', 'key'].concat(_toConsumableArray(whiteProps));
  var querystring = Object.keys(param).filter(function (key) {
    return param[key] !== undefined && param[key] !== '' && whiteList.indexOf(key) < 0;
  }).sort().map(function (key) {
    return key + '=' + JSON.stringify(param[key]);
  }).join("&") + (onlyAppendKeyValue ? "&key=" : '') + secret;
  return (0, _md["default"])(querystring).toUpperCase();
};
/**
 * 早期API，请换用getSignParamsInMD5来调用
 * 对参数对象进行签名，签名结果以_sign结果混合在params中输出
 * @param param
 * @param secret
 * @returns {{_sign: string}}
 */


exports.getSignParamsInMD5 = getSignParamsInMD5;

var signParamsWithMD5 = function signParamsWithMD5(_ref2) {
  var param = _ref2.param,
      secret = _ref2.secret;

  var _sign = getSignParamsInMD5({
    param: param,
    secret: secret
  });

  return _objectSpread2(_objectSpread2({}, param || {}), {}, {
    _sign: _sign
  });
};
/**
 * 对收到的参数对象进行md5签名验证，参数中需要求包含_sign属性
 * @param paramsSigned
 * @param secret
 * @returns {{err: null, success: boolean}|{err: string, success: boolean}}
 */


exports.signParamsWithMD5 = signParamsWithMD5;

var varifyParamsWithMD5 = function varifyParamsWithMD5(_ref3) {
  var paramSigned = _ref3.paramSigned,
      secret = _ref3.secret;
  if (!paramSigned._sign) return {
    success: false,
    err: 'NO_SIGN'
  };
  if (!secret) return {
    success: false,
    err: 'NO_SECRET'
  };

  var _signAgian = getSignParamsInMD5({
    param: paramSigned,
    secret: secret
  });

  if (_signAgian !== paramSigned._sign) return {
    success: false,
    err: 'SIGN_WRONG',
    _needSign: paramSigned._sign,
    _reSign: _signAgian
  };
  return {
    success: true,
    err: null
  };
};
/**
 * 从express的request中获取请求方的IP地址
 * @param req
 * @returns {*}
 */


exports.varifyParamsWithMD5 = varifyParamsWithMD5;

var getClientIp = function getClientIp(req) {
  try {
    return req.headers['x-real-ip'] || req.headers['x-forwarded-for'] || req.connection.remoteAddress || req.socket.remoteAddress || req.connection.socket.remoteAddress;
  } catch (err) {
    return "-not-get-ip";
  }
};
/**
 * 等待指定毫秒时间后再继续执行
 * @param ms
 * @returns {Promise}
 */


exports.getClientIp = getClientIp;

var sleep = function sleep(ms) {
  return new _bluebird["default"](function (resolve, reject) {
    setTimeout(function (_) {
      return resolve(ms);
    }, ms);
  });
};
/**
 * 主动制造一个奔溃，让程序马上停止下来，内部时setTime机制，所以不受外围的try-catch的限制
 * @param title
 */


exports.sleep = sleep;

var crash = function crash(title) {
  setTimeout(function () {
    throw new Error(title || '主动crash');
  }, 20);
};
/**
 * 延迟指定时间执行函数，并捕获错误
 * @param fun
 * @param ms
 * @param errerhandle
 */


exports.crash = crash;

var delayRun = function delayRun(fun, ms, errerhandle) {
  setTimeout(
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee() {
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            _context.next = 3;
            return fun();

          case 3:
            _context.next = 8;
            break;

          case 5:
            _context.prev = 5;
            _context.t0 = _context["catch"](0);
            if (errerhandle) errerhandle(_context.t0);else {
              console.error("error in delayRun:");
              console.error(_context.t0);
            }

          case 8:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[0, 5]]);
  })), ms || 0);
};
/**
 * 获取给定字符串的hashcode值
 * @param str
 * @returns {number}
 */


exports.delayRun = delayRun;

var hashcode = function hashcode(str) {
  var hash = 0,
      i,
      chr,
      len;
  if (str.length === 0) return hash;

  for (i = 0, len = str.length; i < len; i++) {
    chr = str.charCodeAt(i);
    hash = (hash << 5) - hash + chr;
    hash |= 0; // Convert to 32bit integer
  }

  return hash;
};
/*
获取package中的系统名
*/


exports.hashcode = hashcode;

var load_package_name = function load_package_name() {
  var _require = require(_path["default"].join(process.cwd(), 'package.json')),
      _require$name = _require.name,
      name = _require$name === void 0 ? '' : _require$name;

  var applicationName = name.split(".")[0];
  if (!applicationName) throw new Error("\u4E1A\u52A1\u7CFB\u7EDF\u540D\u83B7\u53D6\u5931\u8D25\uFF0C\u6743\u9650\u7BA1\u7406\u8BA4\u8BC1\u5C06\u5931\u6548\uFF0C\u8BF7\u786E\u8BA4\u5B58\u5728package.json\u4E14\u5176\u4E2D\u5DF2\u914D\u7F6Ename\u5C5E\u6027");
  return applicationName;
}; // let res_promise = parallelCallWithPromise({url:'.....'});
// let value = await result;


exports.load_package_name = load_package_name;

var parallelInvokeWithPromise = function parallelInvokeWithPromise(_ref5) {
  var url = _ref5.url,
      _ref5$params = _ref5.params,
      params = _ref5$params === void 0 ? {} : _ref5$params,
      _ref5$timeout = _ref5.timeout,
      timeout = _ref5$timeout === void 0 ? 3000 : _ref5$timeout;
  return new _bluebird["default"](
  /*#__PURE__*/
  function () {
    var _ref6 = _asyncToGenerator(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee2(resolve, reject) {
      var options, res, body, err, result;
      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.prev = 0;
              options = {
                method: "post",
                rejectUnauthorized: false,
                headers: {
                  'Accept': 'application/json, text/plain, */*',
                  'Content-Type': 'application/json'
                },
                json: true,
                body: JSON.stringify(params),
                timeout: timeout
              };
              _context2.next = 4;
              return (0, _nodeFetch["default"])(url, options);

            case 4:
              res = _context2.sent;
              _context2.next = 7;
              return res.json();

            case 7:
              body = _context2.sent;
              err = body.err, result = body.result;

              if (err) {
                reject({
                  err: err.message,
                  result: null
                });
              } else {
                resolve({
                  err: null,
                  result: result
                });
              }

              _context2.next = 16;
              break;

            case 12:
              _context2.prev = 12;
              _context2.t0 = _context2["catch"](0);
              console.error(_context2.t0.stack);
              reject({
                err: _context2.t0.message,
                result: null
              });

            case 16:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, null, [[0, 12]]);
    }));

    return function (_x, _x2) {
      return _ref6.apply(this, arguments);
    };
  }());
};

exports.parallelInvokeWithPromise = parallelInvokeWithPromise;