"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TableSetting = exports.DBUtils = exports.DBModelLoader = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _sequelize = _interopRequireDefault(require("sequelize"));

var DBUtils = _interopRequireWildcard(require("./dbutils"));

exports.DBUtils = DBUtils;

var _util = require("./../class2api/util");

var TableSetting = _interopRequireWildcard(require("./tablesetting"));

exports.TableSetting = TableSetting;

var _GKErrors_Inner = require("../class2api/GKErrors_Inner");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread2(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var _dbList = {};

var _inner_DBModelLoader = function _inner_DBModelLoader(option) {
  //内部初始化
  var sequelize; //内部初始化的sequelize实例子，注意，禁止暴露给外部，以避免安全问题

  var _config_option = option;
  var fn;
  var col;
  var literal;
  var where;

  var _defaultError; //依赖外部数据的初始化


  var _model_objects = {};
  var _ass = {}; //region 初始化sequelize对象

  var _INIT =
  /*#__PURE__*/
  function () {
    var _ref = _asyncToGenerator(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee() {
      var database, user, password, _config_option$host, host, port, replication, timezone, _config_option$dialec, dialect, encrypt, _config_option$pool, pool, _config_option$benchm, benchmark, logging, otherOptions, hasScope;

      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.prev = 0;
              database = _config_option.database, user = _config_option.user, password = _config_option.password, _config_option$host = _config_option.host, host = _config_option$host === void 0 ? 'localhost' : _config_option$host, port = _config_option.port, replication = _config_option.replication, timezone = _config_option.timezone, _config_option$dialec = _config_option.dialect, dialect = _config_option$dialec === void 0 ? 'mysql' : _config_option$dialec, encrypt = _config_option.encrypt, _config_option$pool = _config_option.pool, pool = _config_option$pool === void 0 ? {} : _config_option$pool, _config_option$benchm = _config_option.benchmark, benchmark = _config_option$benchm === void 0 ? process.env.SQL_PRINT === '1' : _config_option$benchm, logging = _config_option.logging, otherOptions = _objectWithoutProperties(_config_option, ["database", "user", "password", "host", "port", "replication", "timezone", "dialect", "encrypt", "pool", "benchmark", "logging"]);
              sequelize = new _sequelize["default"](database, user, password, _objectSpread2(_objectSpread2({
                port: port || (dialect === "mysql" ? 3306 : dialect === 'mssql' ? 1433 : dialect === 'postgres' ? 5432 : 0),
                timezone: timezone || "+08:00",
                pool: _objectSpread2({
                  max: 5,
                  min: 1,
                  idle: 60000,
                  maxIdleTime: 60000
                }, pool)
              }, replication ? {
                replication: replication
              } : {
                host: host
              }), {}, {
                retry: {
                  match: [_sequelize["default"].ConnectionTimedOutError, /PROTOCOL_CONNECTION_LOST/, /ETIMEDOUT/, /EHOSTUNREACH/, /ECONNRESET/, /ECONNREFUSED/, /ETIMEDOUT/, /ESOCKETTIMEDOUT/, /EHOSTUNREACH/, /ER_LOCK_DEADLOCK/, /EPIPE/, /EAI_AGAIN/, /SequelizeConnectionError/, /SequelizeConnectionRefusedError/, /SequelizeHostNotFoundError/, /SequelizeHostNotReachableError/, /SequelizeInvalidConnectionError/, /SequelizeConnectionTimedOutError/],
                  max: 50
                },
                dialect: dialect,
                encrypt: encrypt,
                benchmark: benchmark,
                logging: logging || (process.env.SQL_PRINT === '1' ? function () {
                  var _console;

                  return (_console = console).log.apply(_console, arguments);
                } : null)
              }, otherOptions));
              hasScope = false; //先初始化非Scope的Model

              Object.keys(_model_objects).forEach(function (modelName) {
                var fun = _model_objects[modelName];

                if (!fun.scopeBaseModelName) {
                  _model_objects[modelName] = fun.call();
                } else {
                  hasScope = true;
                }
              });

              if (hasScope) {
                //再初始化Scope类型的Model
                Object.keys(_model_objects).forEach(function (modelName) {
                  var fun = _model_objects[modelName];

                  if (fun.scopeBaseModelName) {
                    _model_objects[modelName] = fun.call(null, _model_objects[fun.scopeBaseModelName]);
                  }
                });
              } //补充初始化model的关联关系


              Object.keys(_model_objects).forEach(function (modelName) {
                if ('associate' in _model_objects[modelName]) {
                  _model_objects[modelName].associate(_model_objects, _ass);
                }
              });
              fn = _sequelize["default"].fn;
              col = _sequelize["default"].col;
              literal = _sequelize["default"].literal;
              where = _sequelize["default"].where; //

              _model_objects.__resetDB = ResetDB;
              _model_objects.__createTransaction = createTransaction;
              _model_objects.__excuteSQL = excuteSQL;
              _model_objects.__fn = fn;
              _model_objects.__col = col;
              _model_objects.__literal = literal;
              _model_objects.__where = where;

              _model_objects.__close = function () {
                sequelize.close();
              };

              _model_objects.__getSequelizeWithDangerous = function () {
                return sequelize;
              };

              _context.next = 29;
              break;

            case 22:
              _context.prev = 22;
              _context.t0 = _context["catch"](0);

              if (!(process.env.NODE_ENV === "production" && _defaultError)) {
                _context.next = 28;
                break;
              }

              throw _defaultError;

            case 28:
              throw _context.t0;

            case 29:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[0, 22]]);
    }));

    return function _INIT() {
      return _ref.apply(this, arguments);
    };
  }();

  var createTransaction =
  /*#__PURE__*/
  function () {
    var _ref2 = _asyncToGenerator(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee2(option) {
      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.prev = 0;
              _context2.next = 3;
              return sequelize.transaction(option);

            case 3:
              return _context2.abrupt("return", _context2.sent);

            case 6:
              _context2.prev = 6;
              _context2.t0 = _context2["catch"](0);

              if (!(process.env.NODE_ENV === "production" && _defaultError)) {
                _context2.next = 12;
                break;
              }

              throw _defaultError;

            case 12:
              throw _context2.t0;

            case 13:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, null, [[0, 6]]);
    }));

    return function createTransaction(_x) {
      return _ref2.apply(this, arguments);
    };
  }();

  var excuteSQL =
  /*#__PURE__*/
  function () {
    var _ref3 = _asyncToGenerator(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee3(sql, options) {
      return _regenerator["default"].wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _context3.prev = 0;
              _context3.next = 3;
              return sequelize.query(sql, options || {});

            case 3:
              return _context3.abrupt("return", _context3.sent);

            case 6:
              _context3.prev = 6;
              _context3.t0 = _context3["catch"](0);

              if (!(process.env.NODE_ENV === "production" && _defaultError)) {
                _context3.next = 12;
                break;
              }

              throw _defaultError;

            case 12:
              throw _context3.t0;

            case 13:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, null, [[0, 6]]);
    }));

    return function excuteSQL(_x2, _x3) {
      return _ref3.apply(this, arguments);
    };
  }();

  var ResetDB =
  /*#__PURE__*/
  function () {
    var _ref4 = _asyncToGenerator(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee4() {
      var _config_option$reset_, key1, key2;

      return _regenerator["default"].wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              _context4.prev = 0;
              _config_option$reset_ = _config_option.reset_key, key1 = _config_option$reset_.key1, key2 = _config_option$reset_.key2;

              if (!(process.env.DB_RESET_1 === key1 && process.env.DB_RESET_2 === key2)) {
                _context4.next = 14;
                break;
              }

              if (!(process.env.NODE_ENV !== 'production')) {
                _context4.next = 11;
                break;
              }

              console.info("DB Inited ... ...");
              _context4.next = 7;
              return sequelize.sync({
                force: process.env.FORCE === "1"
              });

            case 7:
              console.info("DB Inited Done! ");
              return _context4.abrupt("return", true);

            case 11:
              console.error("危险！在production环境执行 Reset操作是被禁止的！");

            case 12:
              _context4.next = 15;
              break;

            case 14:
              console.info("ResetDB 调用失败，重置key无法与process.env.DB_RESET_1、process.env.DB_RESET_2匹配通过！嘿！注意这可是危险操作！");

            case 15:
              return _context4.abrupt("return", false);

            case 18:
              _context4.prev = 18;
              _context4.t0 = _context4["catch"](0);
              console.error("error in ResetDB:");
              console.error(_context4.t0);
              throw _context4.t0;

            case 23:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4, null, [[0, 18]]);
    }));

    return function ResetDB() {
      return _ref4.apply(this, arguments);
    };
  }(); //endregion
  //region 功能代码


  return {
    define: function define(sequelizeModelFactory) {
      var _sequelizeModelFactory = sequelizeModelFactory;
      return function () {
        return _sequelizeModelFactory(sequelize, _sequelize["default"]);
      };
    },
    defineScope: function defineScope(sequelizeModelScopeFactory, baseModelName) {
      var _sequelizeModelScopeFactory = sequelizeModelScopeFactory;

      var fun = function fun(baseModel) {
        return _sequelizeModelScopeFactory(baseModel);
      };

      fun.scopeBaseModelName = baseModelName;
      return fun;
    },
    INIT: function () {
      var _INIT2 = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee5(_ref5) {
        var model, ass, defautError;
        return _regenerator["default"].wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                model = _ref5.model, ass = _ref5.ass, defautError = _ref5.defautError;

                if (model) {
                  _context5.next = 3;
                  break;
                }

                throw new Error("DBModelLoader.INIT() \u672A\u63D0\u4F9Bmodel\u53C2\u6570");

              case 3:
                if (ass) {
                  _context5.next = 5;
                  break;
                }

                throw new Error("DBModelLoader.INIT() \u672A\u63D0\u4F9Bass\u53C2\u6570");

              case 5:
                _defaultError = defautError;
                _model_objects = model;
                _ass = ass;
                _context5.next = 10;
                return _INIT(option);

              case 10:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5);
      }));

      function INIT(_x4) {
        return _INIT2.apply(this, arguments);
      }

      return INIT;
    }(),
    excuteSQL: excuteSQL
  };
}; //内部带放重复创建的功能，相同的mysql配置，确保只创建一份sequelize对象


var DBModelLoader = function DBModelLoader(option) {
  if (!option) {
    throw _GKErrors_Inner.GKErrors._SERVER_ERROR("DBModelLoader\u521D\u59CB\u5316\u51FD\u6570\u672A\u4F20\u5165option\u53C2\u6570");
  }

  if (_typeof(option) !== "object") {
    throw _GKErrors_Inner.GKErrors._SERVER_ERROR("DBModelLoader\u521D\u59CB\u5316\u51FD\u6570\u4F20\u5165\u7684option\u53C2\u6570\u65E0\u6548\uFF08\u671F\u671B\u662F\u4E00\u4E2A\u5BF9\u8C61\u5BF9\u8C61");
  }

  var database = option.database,
      host = option.host,
      port = option.port,
      timezone = option.timezone;
  var hashKey = (0, _util.hashcode)(JSON.stringify({
    database: database,
    host: host,
    port: port
  }));

  if (!_dbList[hashKey]) {
    var loader = _inner_DBModelLoader(option);

    _dbList[hashKey] = loader;
  }

  return _dbList[hashKey];
}; //endregion


exports.DBModelLoader = DBModelLoader;